module taskdb;

alias char[] string;
alias string TaskID;

struct TaskInfo
{
    TaskID  ID;
    string  Title;
}

enum TaskStatus {
    unchanged = 0,
    Resolved
}
/*
class TaskUpdate
{
    string	Comment;
    uint	TimeWorked = 0;
    TaskStatus	Status = TaskStatus.unchanged;

    abstract void Execute();
}

class TaskUpdateRT : TaskUpdate
{
    TaskDB	DB;
    TaskID	ID;

    this( TaskDB db, TaskID id) { DB=db; ID=id; }

    void Execute()
    {
	// TODO
    }
}
*/
struct TaskUpdate
{
    TaskID	ID;
    string	Comment;
    uint	TimeWorked = 0;
    TaskStatus	Status = TaskStatus.unchanged;
}

interface TaskDB
{
    void	Open();
    TaskInfo[]  QueryTasks();
    void	Update( TaskUpdate tu );
}

